#ifndef _GILASS_H_
#define _GILASS_H_



#include <queue>
#include <list>
#include <vector>
#include <string>
#include <iostream>
using namespace std;




class Except{
public:
	string message;
	Except(string message){this->message = message;}
};


struct Tree{
	char data;
	Tree * left;
	Tree * right;
	Tree * identical;
	int result;
	bool cherry;

	Tree(char data){
		left = right = identical = NULL;
		cherry = 0;
		this->data = data;
	}
};

struct Output{
	int val;
	Tree * wherethehell;
	Output(Tree * where){wherethehell = where; val = 1;}
};


//bool list<Tree*>::operator < ( const Tree* , const Tree* );

class DAG{
public:
	DAG(string infix);
	~DAG();
	
	int calculator(){return calculate(root);}
	int result();
	string statistic();
private:
	vector<Output> numiden;
	list<Tree *> cherries;
	Tree * root;
	string infix;
//	void copy( Tree* t);
	queue<Tree *> myqueue;
	//vector<Tree*> nodes;
/*
	int max(int a,int b){
		if (a > b) return a;
		else return b;
	}
	int heighter(Tree * root);
*/	void dagger();
	void BFS();
	void equal();
	Tree * myGenerate(string infix);
	bool isEqual( Tree* t1, Tree* t2);
	bool priority( char a, char b);
	int calculate(Tree * node);
	void delete4des(Tree * where2del);
	string intstring(long int number);
	string infixpar(Tree * wow);
};








#endif